# # #
# /33/object_not.rb
# (c) 2010 Jan Lelis <mail@janlelis.de>. MIT License.
# See: https://rbjl.janlelis.com/33-new-features-of-ruby-zucker-version-2-and-3
# # #

class Object
  def not
    NotClass.new self
  end

  class NotClass < BasicObject
    def initialize(receiver)
      @receiver = receiver
    end

    def method_missing(m, *args, &block)
      not @receiver.public_send( m, *args, &block ) # this not is the built-in not operator
    end
  end
end

# usage
#  [1,2,3].not.empty? # true
